unit ucommw32;
interface
uses  sysutils,windows;
const  monport:string='Com2:';
  nul=chr(0);
 chaineinit:string='baud=1200 parity=e data=7 stop=1' + NUL;
 timeoutms:word=1000;
 nbattendu:word=80;
 var
DeviceName: Array[0..80] of Char;
ComFile: THandle;
commprop:Tcommprop;
Const
 RxBufferSize = 256;
TxBufferSize = 256;
 Var
DCB: TDCB;
Config : String;
CommTimeouts : TCommTimeouts;
errs:dword;
stat:Tcomstat;
 procedure envoiechaine(s:string);
 function recoitchaine:string;
 function recoitcar:char;
 function recoitchaineRC:string;
function recoitnbcar(n:word):string;
  procedure initialise;
  function enattente:word;
  procedure ferme;
//compatibilit orphy
function comcarpresent(portcom:integer):boolean;
 function comreadch(portcom:integer):char;
procedure comwrite (portcom:integer ; chaine:string);

implementation

 procedure envoiechaine(s:string);
 Var
BytesWritten: dword;
begin
 if not WriteFile (ComFile, s[1], Length(s), BytesWritten, Nil) then;{ Raise an exception }
end;

function recoitchaine:string;
Var
d: array[1..255] of Char;
s: String;
BytesRead, i: dword;
begin
s := '';
if enattente>0
  then begin
    readfile(comfile,d,enattente,bytesread,nil);
    for i := 1 to BytesRead do s := s + d[I];
    end;
recoitchaine:=s;
end;

function recoitchaineRC:string;
var d:array[1..2] of char;
s:string;
bytesread,i,t0,memoenattente:dword;
begin
s:=''; t0:=gettickcount;
repeat
  memoenattente:=enattente;
  if memoenattente>0 then begin
      readfile(comfile,d,1,bytesread,nil);
      s:=s+d[1];
      end;
until ((length(s)>0)and(s[length(s)]=chr(13)))or(gettickcount-t0>timeoutms);
recoitchainerc:=copy(s,1,pos(chr(13),s)-1);
end;

function recoitnbcar(n:word):string;
var d:array[1..2] of char;
s:string;
bytesread,i,t0,memoenattente:dword;
begin
s:=''; t0:=gettickcount;
repeat
  memoenattente:=enattente;
  if memoenattente>0 then begin
      readfile(comfile,d,1,bytesread,nil);
      s:=s+d[1];
      end;
until ((length(s)=n)or(gettickcount-t0>timeoutms));
recoitnbcar:=s;
end;


function recoitcar:char;
var moncar:char;
t0,i:dword;
begin
t0:=gettickcount;
repeat
if enattente>0 then readfile(comfile,moncar,1,i,nil);
until (i>0)or(gettickcount>t0+timeoutms);
recoitcar:=moncar;
end;

procedure initialise;
begin
StrPCopy(DeviceName, monport);
ComFile := CreateFile(DeviceName, GENERIC_READ or GENERIC_WRITE, 0, Nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
if ComFile = INVALID_HANDLE_VALUE then;{ Raise an exception }
if not SetupComm(ComFile, RxBufferSize, TxBufferSize) then;{ Raise an exception }
if not GetCommState(ComFile, DCB) then;{ Raise an exception }
Config :=chaineinit;
if not BuildCommDCB(@Config[1], DCB) then;{ Raise an exception }
if not SetCommState(ComFile, DCB) then;{ Raise an exception }
with CommTimeouts do
begin
ReadIntervalTimeout := 0;
ReadTotalTimeoutMultiplier := 0;
ReadTotalTimeoutConstant := timeoutms;
WriteTotalTimeoutMultiplier := 0;
WriteTotalTimeoutConstant := timeoutms;
end;
if not SetCommTimeouts(ComFile, CommTimeouts) then;{ Raise an exception }
end;

procedure ferme;
begin
CloseHandle(ComFile);
end;
function enattente:word;
begin
  clearcommerror(comfile,errs,@stat);
  enattente:=stat.cbinque;
end;
function comcarpresent(portcom:integer):boolean;
begin
  if enattente>0 then comcarpresent:=true else comcarpresent:=false;
end;
function comreadch(portcom:integer):char;
begin
    comreadch:= recoitcar;
end;
procedure comwrite (portcom:integer ; chaine:string);
begin
  envoiechaine(chaine);
end;
end.
